From 2a7b26b8b5064cc353acf36ed9a476230e0f5de5 Mon Sep 17 00:00:00 2001
From: tioguda <guda.flavio@gmail.com>
Date: Wed, 10 Mar 2021 14:05:42 -0300
Subject: 5.10


diff --git a/kernel/common/inc/nv-linux.h b/kernel/common/inc/nv-linux.h
index ca02448..56c249f 100644
--- a/kernel/common/inc/nv-linux.h
+++ b/kernel/common/inc/nv-linux.h
@@ -179,6 +179,9 @@ static inline uid_t __kuid_val(kuid_t uid)
 
 #include <linux/pagemap.h>
 #include <linux/dma-mapping.h>
+#if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+#include <linux/dma-map-ops.h>
+#endif
 
 #if defined(CONFIG_SWIOTLB) && defined(NVCPU_AARCH64)
 #include <linux/swiotlb.h>
diff --git a/kernel/conftest.sh b/kernel/conftest.sh
index 0e0cecd..8bfeb23 100755
--- a/kernel/conftest.sh
+++ b/kernel/conftest.sh
@@ -134,6 +134,7 @@ test_headers() {
     FILES="$FILES xen/ioemu.h"
     FILES="$FILES linux/fence.h"
     FILES="$FILES linux/dma-resv.h"
+    FILES="$FILES linux/dma-map-ops.h"
     FILES="$FILES linux/ioctl32.h"
 
     # Arch specific headers which need testing
@@ -1457,6 +1458,9 @@ compile_test() {
             #
             CODE="
             #include <linux/dma-mapping.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void conftest_phys_to_dma(void) {
                 phys_to_dma();
             }"
@@ -1471,6 +1475,9 @@ compile_test() {
             #
             CODE="
             #include <linux/dma-mapping.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void conftest_dma_ops(void) {
                 (void)dma_ops;
             }"
@@ -1485,6 +1492,9 @@ compile_test() {
             #
             CODE="
             #include <linux/dma-mapping.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void conftest_dma_ops(void) {
                 (void)swiotlb_dma_ops;
             }"
@@ -1507,6 +1517,9 @@ compile_test() {
             #
             CODE="
             #include <linux/dma-mapping.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void conftest_get_dma_ops(void) {
                 get_dma_ops();
             }"
@@ -1527,6 +1540,9 @@ compile_test() {
             #
             CODE="
             #include <linux/dma-mapping.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void conftest_noncoherent_swiotlb_dma_ops(void) {
                 (void)noncoherent_swiotlb_dma_ops;
             }"
@@ -3547,6 +3563,9 @@ compile_test() {
             #
             CODE="
             #include <linux/pm.h>
+            #if defined(NV_LINUX_DMA_MAP_OPS_H_PRESENT)
+            #include <linux/dma-map-ops.h>
+            #endif
             void pm_runtime_conftest(void) {
                 struct dev_pm_info dpmi;
                 dpmi.timer_expires = 1;
diff --git a/kernel/nvidia-drm/nvidia-drm-gem-user-memory.c b/kernel/nvidia-drm/nvidia-drm-gem-user-memory.c
index 5109767..cae92ff 100644
--- a/kernel/nvidia-drm/nvidia-drm-gem-user-memory.c
+++ b/kernel/nvidia-drm/nvidia-drm-gem-user-memory.c
@@ -20,6 +20,7 @@
  * DEALINGS IN THE SOFTWARE.
  */
 
+#include <linux/version.h>
 #include "nvidia-drm-conftest.h"
 
 #if defined(NV_DRM_AVAILABLE)
@@ -47,8 +48,13 @@ static struct sg_table *__nv_drm_gem_user_memory_prime_get_sg_table(
 {
     struct nv_drm_gem_user_memory *nv_user_memory = to_nv_user_memory(nv_gem);
 
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 10, 0))
+    return drm_prime_pages_to_sg(nv_gem->nv_dev->dev, nv_user_memory->pages,
+				 nv_user_memory->pages_count);
+#else
     return drm_prime_pages_to_sg(nv_user_memory->pages,
                                  nv_user_memory->pages_count);
+#endif
 }
 
 static void *__nv_drm_gem_user_memory_prime_vmap(
